//                              -*- Mode: C++ -*-
//: ESEMSPOS.hh
//
//
// Author: Mauro Villa   
// ECAL group 
// HERA-B experiment, Desy
// e-mail: villa@bo.infn.it
//
// Created 14/6/98
// Last Update ........
//

#ifndef ESEMSPOS_HH_
#define ESEMSPOS_HH_

#include "care/ESCorCOGPos.hh"
#include "care/ELNearCells.hh"

/**
class ESEMSPOS.
  It finds better extimations of the starting point of an
  electromagnetic shower.
*/

class ESEMSPos :  public ESCorCOGPos {
public:

  /// Constructor
  ESEMSPos();
  /// Destructor: currently void but needs to be virtual
  virtual ~ESEMSPos();
 
  /**@name Beheavioral methods */
  //@{ 
  ///   Evaluate the position for a cluster.
  virtual void evaluatePos(const EMCluster* clus);

  /// EMHitCell Analyzer : redefined!
  virtual void doAnalysis(const EMHitCell * hitT);

  //@}

private:
  // The near cell object
  ELNearCells nearCells;
};



#endif // ESEMSPOS_HH_

