
/**********************************************************************/
//
// $Source: /afs/desy.de/group/hera-b/repository/ARTE/cluearte/CustomTrack.C,v $
// $Revision: 1.4 $
// $Author: natasha $
// $Date: 1999/08/31 10:43:01 $
//
// Created: 07-23-99,   C. Borgmeier
//
/**********************************************************************/


#include <Clue/CustomTrack.hh>


VDS_Track::VDS_Track( ArtePointer<RSEG> rseg )
  : RecoSegment( rseg )
{
  nF = short(rseg->time + rseg->dtim - 4 + .5 );
}


RICH_Track::RICH_Track( ArtePointer<RSEG> rseg )
  : RecoSegment( rseg ),
    radius( rseg->time ),
    signalPhotons( rseg->ze ),
    backgndPhotons( rseg->ye ),
    fraction( rseg->zf )
{
  param.x = 0;
  param.y = 0;
  param.z = 1000;
  param.covTxP_Inv = 0;
  param.covTyP_Inv = 0;
  param.covP_Inv   = 0;
}


OTR_SpacePoint::OTR_SpacePoint( ArtePointer<RSEG> rseg )
  : RecoSegment( rseg ),
    nHits( distance( rseg->rhit.begin(), rseg->rhit.end() ) )
{
}


MuonTrack::MuonTrack( ArtePointer<RSEG> rseg )
  : RecoSegment( rseg )
{
}
