
/**********************************************************************/
//
// $Source: /afs/desy.de/group/hera-b/repository/ARTE/cluearte/RecoTrack.C,v $
// $Revision: 1.4 $
// $Author: natasha $
// $Date: 1999/08/31 10:43:03 $
//
// Created: 01-27-97,   I. Siccama, C. Borgmeier
//
/**********************************************************************/


#include <algo.h>

#include <arte/artefunc.h>
#include <Clue/RecoTrack.hh>


RecoTrack::RecoTrack( ArtePointer<RTRA> rtra )
  : RecoSegment( rtra ),
    m( rtra!=0 ? rtra->topp!=0? rtra->topp->mass: 0 : 0 ),
    
    flr ( rtra!=0? rtra->flr : 0 ),
    flt ( rtra!=0? rtra->flt : 0 ),
    fle ( rtra!=0? rtra->fle : 0 ),
    flm ( rtra!=0? rtra->flm : 0 ),

    lre ( rtra!=0? rtra->lre : 0 ),
    lrmu( rtra!=0? rtra->lrmu: 0 ),
    lrpi( rtra!=0? rtra->lrpi: 0 ),
    lrk ( rtra!=0? rtra->lrk : 0 ),
    lrp ( rtra!=0? rtra->lrp : 0 ),
  
    lte ( rtra!=0? rtra->lte : 0 ),
    lth ( rtra!=0? rtra->lth : 0 ),

    lee ( rtra!=0? rtra->lee : 0 ),
    lemi( rtra!=0? rtra->lemi: 0 ),
    leh ( rtra!=0? rtra->leh : 0 ),

    lmmu( rtra!=0? rtra->lmmu: 0 ),
    lmh ( rtra!=0? rtra->lmh : 0 ),

    fit( rtra!=0? rtra->fit: 0 ),   
    charge( rtra!=0? ( rtra->pf )<0? -1: 1: 0 ),

    hsi( rtra!=0? rtra->hsi: 0 ),
    hin( rtra!=0? rtra->hin: 0 ),
    hou( rtra!=0? rtra->hou: 0 ),
    hri( rtra!=0? rtra->hri: 0 ),
    hca( rtra!=0? rtra->hca: 0 ),
    htr( rtra!=0? rtra->htr: 0 ),
    hmu( rtra!=0? rtra->hmu: 0 )
{
}


RecoTrack::RecoTrack( ArtePointer<RSEG> rtra )
  : RecoSegment( rtra ),

    m( 0 ),
  
    fit( rtra->fit ),
    charge( fit==0?( rtra->pf )<0? -1: 1 : 0 ),

    //
    // sorry for this wild piece. should be changed in future.
    //
    hsi( count_if( rtra->hitb.begin(), rtra->hitb.end(),
		   compose1( bind2nd( equal_to<int>(),
				      1 ),
			     compose1( getEntry( &GEDE::cmp ), 
				       getEntry( &HITB::gede ) )
			     )
		   )
	 ),
    hin( count_if( rtra->hitb.begin(), rtra->hitb.end(),
		   compose1( bind2nd( equal_to<int>(),
				      3 ),
			     compose1( getEntry( &GEDE::cmp ), 
				       getEntry( &HITB::gede ) )
			     )
		   )
	 ),
    hou( count_if( rtra->hitb.begin(), rtra->hitb.end(),
		   compose1( bind2nd( equal_to<int>(),
				      2 ),
			     compose1( getEntry( &GEDE::cmp ), 
				       getEntry( &HITB::gede ) )
			     )
		   )
	 ),
    hri( count_if( rtra->hitb.begin(), rtra->hitb.end(),
		   compose1( bind2nd( equal_to<int>(),
				      5 ),
			     compose1( getEntry( &GEDE::cmp ), 
				       getEntry( &HITB::gede ) )
			     )
		   )
	 ),
    hca( count_if( rtra->hitb.begin(), rtra->hitb.end(),
		   compose1( bind2nd( equal_to<int>(),
				      7 ),
			     compose1( getEntry( &GEDE::cmp ), 
				       getEntry( &HITB::gede ) )
			     )
		   )
	 ),
    htr( count_if( rtra->hitb.begin(), rtra->hitb.end(),
		   compose1( bind2nd( equal_to<int>(),
				      6 ),
			     compose1( getEntry( &GEDE::cmp ), 
				       getEntry( &HITB::gede ) )
			     )
		   )
	 ),
    hmu( count_if( rtra->hitb.begin(), rtra->hitb.end(),
		   compose1( bind2nd( equal_to<int>(),
				      4 ),
			     compose1( bind2nd( divides<int>(),
						2 ),
				       compose1( getEntry( &GEDE::cmp ), 
						 getEntry( &HITB::gede ) )
				       )
			     )
		   )
	 )
{
  rTrack.setInt( rtra - *ArteTable<RSEG>::begin() + 1 );
}
