//                              -*- Mode: C++ -*-
//:dgcalech.C
// 
//:description - ENERGY -> ADC CHANNEL CONVERSION
//
// Author: Benedetto Giacobbe   
// ECAL group 
// HERA-B experiment, Desy
// e-mail: giacobbe@bo.infn.it
//
// Created 26/7/97
// Last Update ........
//

#include <stdlib.h>
#include <math.h>
#include "arte/arte.hh"
#include "care/dgcal.hh"
#include "care/ECHF_status.hh"

extern "C" void  granor_(float * y1,float *y2);

int dgcalech(int idcell, float mc_en){
  
  float y1 = 0.0, y2 = 0.0;
  int ich = 0;
  ArtePointer<ECHS> echs(idcell);      
  ArtePointer<ECHF> echf(idcell);      
  if((echf->stat & Echfs::usable) == Echfs::usable){
    // if channel is on & low noisy & calibration was ok    

    /* ENERGY -> ADC CONVERSION */
    
    float q_ch = (mc_en) / echs->thrs; // in DAQ COUNTS
    
    // ADC channel relative to DAC channel (proportional to charge) q_ch
    //  To change as soon as possible
    float ch = (-echs->pcal[0]+q_ch)/echs->pcal[1];
    
    // sum of alterated pedestal 
    
    granor_(&y1,&y2);	      
    y1 *= echf->wid;
    y1 += echf->pedf;
    ch += y1;
    ich = (int)(ch);
    if(ich<0) ich = 0;
    /* **************************************************** */      
    /* CONVERSION ADC - > ENERGY for check : temporary call */ 
    /*      float en_rec = dgcalche(idcell, ich);           */
    /* **************************************************** */   
    // cout<<"Energy: "<<mc_en<<"  Q: "<<q_ch<<"  channel: "<<ich<<endl;
  }                                          
  return ich;
}                                           







