      SUBROUTINE DGMASK(FLAG)

************************************************************************
*
* DGMASK
* written by Thomas Lohse 05/99
*
* Input:   FLAG    (I)
* 
* Output:   --
* 
* Action:  FLAG = +1 ==> Shift all MIMPs in areas to be cut out (dgcut)
*                        out of the detector. Set energy release of MCALs
*                        to zero in these regions.
*          FLAG = -1 ==> Shift the MIMPs back into the detector.
* 
* 
************************************************************************

      IMPLICIT NONE

      INTEGER I,J,IGEDE,IGESL,ICMP,FLAG
      INTEGER blCe, esl, block, cell
      REAL X, Y
      CHARACTER*4 SLNAM

#include "arte/Arte.fi"
#include "arte/ArteFlag.fi"
#include "auto/GEO.fi"
#include "auto/MC.fi"
#include "digi/dgcut.fi"

#include "arte/Arte.ff"
#include "auto/GEO.ff"
#include "auto/MC.ff"


c--  loop over all MIMPs, shift them out of the detector
c--  if they are positioned inside masked areas

      IF (NCUTDG.GT.0.AND.FLAG.GT.0) then

        DO 100 I = 1,NMIMP()

          X     = FMIMP_X(I)
          Y     = FMIMP_Y(I)
          IGEDE = IMIMP_GEDE(I)
          IGESL = OGEDE_GESL(IGEDE)
          WRITE(SLNAM,'(A4)') HGESL_NAME(IGESL)
          ICMP  = IGESL_CMP(IGESL)

          DO 50 J = 1,NCUTDG

            IF (DGCUOP(J).EQ.'CMP') THEN
              IF (ICMP.NE.DGCUCI(J))  GO TO 50
            ELSE
              IF (SLNAM.NE.DGCUCO(J)) GO TO 50
            ENDIF
            IF (X.LE.XCUMIN(J))       GO TO 50
            IF (X.GE.XCUMAX(J))       GO TO 50
            IF (Y.LE.YCUMIN(J))       GO TO 50
            IF (Y.GE.YCUMAX(J))       GO TO 50
            IF (X.GE.0.) THEN
              X = 1000.*(X+1.)
            ELSE
              X = 1000.*(X-1.)
            ENDIF
            Q(QMIMP_X(I)) = X
            GO TO 100

  50      CONTINUE

 100    CONTINUE

c--  loop over all MCALs, reset their energies to zero if they are located
c--  inside masked areas

        DO 250 J = 1,NCUTDG

          IF (DGCUOP(J).EQ.'CMP') THEN
            IF (DGCUCI(J).NE.7)       GO TO 250
          ELSE
            IF (DGCUCO(J).NE.'CALW')  GO TO 250
          ENDIF

          DO 200 I = 1, NMCAL()

            blCe = iand(imcal_gcal(I),16777215)
            esl = (imcal_gcal(I) - blCe) / 16777216
            block = blCe / 100
            cell = mod(blCe,100)
            
            if (block.ge.1.and.block.le.ngcal()) then
              X = (FGCAL_XMIN(block) + FGCAL_XMAX(block))*0.5
              Y = (FGCAL_YMIN(block) + FGCAL_YMAX(block))*0.5
              IF (X.LE.XCUMIN(J))       GO TO 200
              IF (X.GE.XCUMAX(J))       GO TO 200
              IF (Y.LE.YCUMIN(J))       GO TO 200
              IF (Y.GE.YCUMAX(J))       GO TO 200
            endif

            Q(QMCAL_DE(I)) = 0.

 200      CONTINUE

 250    CONTINUE

      ENDIF

c--  loop over all MIMPs, shift them back into the detector
c--  if they were shifted out above

      IF (NCUTDG.GT.0.AND.FLAG.LT.0) THEN

        DO 400 I = 1,NMIMP()

          X     = FMIMP_X(I)
          IF (ABS(X).GE.1000.) THEN
            IF (X.GE.0.) THEN
              X = 0.001*X - 1.
            ELSE
              X = 0.001*X + 1.
            ENDIF
            Q(QMIMP_X(I)) = X
          ENDIF

 400    CONTINUE

      ENDIF

 999  RETURN
      END

