
/*********************************************************************
*-- Author :    Vik   11/11/98
*               updated July 99 by S.Nowak 
* Description: TRD DIGI
*
* Called from: DGEVNT
* Arguments: gede plane ipl
*
********************************************************************/
#include <math.h>
#include <vector.h>
#include "arte/arte.hh"
#include "arte/ArteMessage.hh"
#include "digi/zgdig.hh"
#include "digi/cr_HepRot.hh"
#include "gean/ZGESL.h"
#include "gean/ZGDETV.h"


/*
      integer trdmimp, trd_mimp_bl, nmim, ifmimp, mxhit, ih
      real trd_mimp_x1, trd_mimp_y1, trd_mimp_z1,
     +                  trd_mimp_x16, trd_mimp_y16, trd_mimp_z16
      character*600 trdmimpvalues40
      common /trd_mimp/ trd_mimp_x1, trd_mimp_y1, trd_mimp_z1,
     +                  trd_mimp_x16, trd_mimp_y16, trd_mimp_z16,
     +                  trd_mimp_bl
*/
extern "C" {
  void dgtrdf_(int &);
  void sortzv_(int[], int[], int&, int&, int&, int&);
  void mmbook_(int &, const int &);    
}

void dgtrdf_(int & ipl) {
   int nmim=0, ifmimp=0, i0 = 0, mi1 = -1;   
 
   ArtePointer<GEDE> gd(ipl);
   zgdig ZGDIG(ipl);

   nmim = ZGDIG.Get_nmimp(ifmimp);
   if(nmim  <= 0) {
      ZGDIG.Set_hit_for_nomimp();
      return;
   }

   vector<digx> *dg_trd = NULL;
   int          *dg_srt = NULL;
   int          *ind    = NULL;
   int          *ind1   = NULL;

   int n_wire = gd->nwi[0]; int n_straw;
   cr_HepRot rm;  rm.set_HepRot(ipl);

   digx trddg;
   dg_trd = new vector<digx>;

   for(int ih=0;ih<nmim;ih++) {
      ArtePointer<MIMP> mp(ih+ifmimp);
         float x0[3],  x_rot[3], tx0[3],  tx_rot[3]; 
         if(mp->z <1.) continue; 
         x0[0] = mp->x;
         x0[1] = mp->y;
         x0[2] = 0.;  
         rm.rotate_Z(x0,x_rot);              //rotate x into wire orientation  
         tx0[0] = mp->tx;   
         tx0[1] = mp->ty;   
         tx0[2] = 0.; 
         rm.rotate_Z(tx0,tx_rot);           //rotate tx into wire orientation
         float cx_rot = 0.;
         if(fabs(tx_rot[0]) < 1.e+10) cx_rot = 1./sqrt(1.+ tx_rot[0]*tx_rot[0]);

//       number of straw calc.
         float xtv = x_rot[0] + tx_rot[0]*(mp->z-gd->zmin); 
         float xth = x_rot[0] + tx_rot[0]*(gd->zmax-mp->z);  
         int nv = int((xtv - gd->xmin)/gd->pit) + 1; 
         int nh = int((xth - gd->xmin)/gd->pit) + 1; 
         int isn =0;
         if(nv <= 0 && nh <= 0)  continue; 
         if(nv > n_wire && nh > n_wire) continue; 
         if(nv > nh) {
	    isn=-1;
            if(nv > n_wire) nv = n_wire;
            if(nh < 1) nh = 1;
         }
         else {
	    isn = 1;
            if(nv < 1) nv = 1;
            if(nh > n_wire) nh = n_wire;
         }

//       position in wire plane 
         float x_new = x_rot[0] - gd->xmin + tx_rot[0] * (gd->zfw[0] - mp->z);
         n_straw = nv;
         for(;;) {     
            float x_dd = (x_new - (float(n_straw)-.5) * gd->pit) * cx_rot;
/*          smear the drift distance according to ACC and accept effectivity
            int i1=1; 
            float rndm[2] = {0.,0.};
            granor_(rndm[0],rndm[1]);
            x_dd = x_dd + gd->acc*rndm[0];
            grndm_(rndm,i1);
            if(rndm[0] > gd->eff) continue;   
*/     
            if(fabs(x_dd) < .5 * gd->pit) {
               trddg.strip = n_straw;                    // strip number
               trddg.charge = x_dd;                      // distance
               trddg.mimp = mp.index();                  // mimp number
               ArtePointer<MTRA> mt = mp->mtra;
               trddg.track = mt.index() ;                // track number
               dg_trd->push_back(trddg);
            }
            if(n_straw == nh) break;
            n_straw = n_straw + isn;
       }
  }

  int ndigde = dg_trd->size();      
  if(ndigde <= 0) { 
     ZGDIG.Set_hit_for_nomimp();
     goto L99;       
  }

  dg_srt = new int[ndigde];
  ind    = new int[ndigde];
  ind1   = new int[n_wire];
  for (int i=0; i<ndigde; i++) ind[i]  = 0; 
  for (int i=0; i<n_wire; i++) ind1[i] = 0; 
 
  for(int i=0; i<ndigde; i++) {
     vector<digx>::iterator dg = dg_trd->begin() + i;
     dg_srt[i] = dg->strip;
  }    

//sort the digit matrix  due to increasing strip nr
  sortzv_(dg_srt,ind,ndigde,mi1,i0,i0);

// the next loop cleans the digits and fills digb and hitb banks and relations
// In principle ther should be  a code which makes clustering of digits to hits
// since we dont have it at the moment the hits will be obtained directly
// from the mimps, i.e. in parallel to the digits.
// Note that only digits and hits will be stored for which the deposit energy
// in the cell is bigger then e_thr)  

  int iflag = 0,   iflag1 = 0;
   for(int ih = 0; ih < ndigde; ih++) {
//   first the digits
     vector<digx>::iterator dg = dg_trd->begin() + ind[ih] - 1;
     mmbook_(ArtePointer<DIGB>::getLink().getRef(),1);
     int nn1 =ArtePointer<DIGB>::nrow() ;
     ArtePointer<DIGB> dgb(nn1);
     if(iflag == 0) {        // first digit in this detector
        gd->dig1 = nn1;        iflag = 1;
     }
     dgb->id  = 10000*dg->strip + ipl ;
     dgb->q   = dg->charge;
     if(dg->mimp) createRelation(ArtePointer<MIMP>(dg->mimp),dgb,&MIMP::digb);
     gd->digl = nn1;
     createRelation(ArtePointer<MIMP>(dg->mimp),dgb,&MIMP::digb);

//   next the hitb bank
     ArtePointer<HITB> htb;

     if(!ind1[dg->strip-1] ) {    
        mmbook_(ArtePointer<HITB>::getLink().getRef(),1);
        int nn = ArtePointer<HITB>::nrow();
        htb = ArtePointer<HITB>(nn);
        if(!iflag1) {
	  gd->hit1 = nn;    iflag1 =1;
        }
        gd->hitl = nn;
        htb->gede = ipl;
        htb->x  = gd->xmin + (float(dg->strip)-.5) * gd->pit;
        htb->z  = gd->zfw[0];
        htb->q  = dg->charge;           
        htb->r  = gd->acc;
        ind1[dg->strip-1] = nn;
     }
     else {
        htb = ArtePointer<HITB>(ind1[dg->strip-1]);
        if(fabs(dg->charge) < fabs(htb->q)) htb->q = dg->charge;
     }    
     createRelation (ArtePointer<MIMP>(dg->mimp),htb,&MIMP::hitb);
     createRelation (htb,dgb,&HITB::digb);
  } 

L99: 
  if(dg_trd != NULL)  {delete dg_trd;      dg_trd = NULL;}
  if(ind != NULL)     {delete [] ind;      ind    = NULL;}
  if(ind1 != NULL)    {delete [] ind1;     ind1   = NULL;}
  if(dg_srt != NULL)  {delete [] dg_srt;   dg_srt = NULL;}
      
}

// End of DGTRDF

