
/*********************************************************************
*-- Author :    Vik   11/11/98
*               updated July 99 by S.Nowak 
* Description: TRD DIGI
*
* Called from: DGEVNT
* Arguments: gede plane ipl
*
********************************************************************/
#include <math.h>
#include <vector.h>
#include "arte/arte.hh"
#include "arte/ArteMessage.hh"
#include "arte/ArteUtil.h"
#include "digi/zgdig.hh"
#include "digi/cr_HepRot.hh"
#include "gean/ZGESL.h"
#include "gean/ZGDETV.h"


/*
      integer trdmimp, trd_mimp_bl, nmim, ifmimp, mxhit, ih
      real trd_mimp_x1, trd_mimp_y1, trd_mimp_z1,
     +                  trd_mimp_x16, trd_mimp_y16, trd_mimp_z16
      character*600 trdmimpvalues40
      common /trd_mimp/ trd_mimp_x1, trd_mimp_y1, trd_mimp_z1,
     +                  trd_mimp_x16, trd_mimp_y16, trd_mimp_z16,
     +                  trd_mimp_bl
*/
extern "C" {
  void dgtrds_(int &);
  void sortzv_(int[], int[], int&, int&, int&, int&);
  void mmbook_(int &, const int &);    
}

void dgtrds_(int & ipl) {
   int nmim=0, ifmimp=0, i0 = 0, mi1 = -1;   
 
   ArtePointer<GEDE> gd(ipl);
   zgdig ZGDIG(ipl);

   nmim = ZGDIG.Get_nmimp(ifmimp);
   if(nmim  <= 0) {
      ZGDIG.Set_hit_for_nomimp();
      return;
   }

   vector<digx> *dg_trd = NULL;
   int          *dg_srt = NULL;
   int          *ind    = NULL;
   int          *ind1   = NULL;
   float        *de     = NULL;

   float  e_thr =5.0;

   int n_wire = gd->nwi[0]; int n_straw;
   cr_HepRot rm;  rm.set_HepRot(ipl);

   de = new float[n_wire];
   for (int i=0; i<n_wire; i++) de[i] = 0;   

   digx trddg;
   dg_trd = new vector<digx>;

   for(int ih=0;ih<nmim;ih++) {
      ArtePointer<MIMP> mp(ih+ifmimp);
      if(mp->z < .1) {
         n_straw= mp->gede.index() >>16;
         if(n_straw <= 0 || n_straw > n_wire) {
            arteMsg << "dgtrds: n_straw for de-MIMP = " << n_straw ;
            arteMsg.error();         
         } 
         de[n_straw-1] += mp->tx;
         continue;
      }
      else if(mp->z > 1000.) {

         float x0[3],  x_rot[3], tx0[3],  tx_rot[3]; 
         x0[0] = mp->x; 
         x0[1] = mp->y; 
         x0[2] = 0.;  
         rm.rotate_Z(x0,x_rot);              //rotate x into wire orientation  
         tx0[0] = mp->tx;   
         tx0[1] = mp->ty;   
         tx0[2] = 0.; 
         rm.rotate_Z(tx0,tx_rot);           //rotate tx into wire orientation
         float cx_rot = 0.;
         if(fabs(tx_rot[0]) < 1.e+10) cx_rot = 1./sqrt(1.+ tx_rot[0]*tx_rot[0]);

//       number of straw calc.
         n_straw= mp->gede.index() >>16;
         float x_new = x_rot[0]-gd->xmin; 
         if(!n_straw) n_straw = int(x_new/gd->pit) + 1;

//       swim into the wire plane
         float deltaz = gd->zfw[0] - mp->z;
         x_new = x_new + tx_rot[0] * deltaz;

//       distance to wire 
         float x_dd = (x_new - (float(n_straw)-.5) * gd->pit) * cx_rot;
         if(fabs(x_dd) > .5*gd->pit + 1.e-5 ) {
            int storenr = 8978914 ; int ilarge = AR_ILARGEST;
            memesc_(&storenr,&i0,&ilarge,"dgtrds: x_dd > .5*pitch",23);
	 }
/*       smear the drift distance according to ACC and accept effectivity
         int i1=1; 
         float rndm[2] = {0.,0.};
         granor_(rndm[0],rndm[1]);
         x_dd = x_dd + gd->acc*rndm[0];
         if(fabs(dd) > .5 * gd_>pit) continue;
         grndm_(rndm,i1);
         if(rndm[0] > gd->eff) continue;   
*/     

         trddg.strip = n_straw;                    // strip number
         trddg.charge = x_dd;                      // distance
         trddg.mimp = mp.index();                  // mimp number
         ArtePointer<MTRA> mt = mp->mtra;
         trddg.track = mt.index() ;                // track number
         dg_trd->push_back(trddg);
     }
  }

  int ndigde = dg_trd->size();      
  if(ndigde <= 0) {
     ZGDIG.Set_hit_for_nomimp();
     goto L99;       
  }
 
  dg_srt = new int[ndigde];
  ind    = new int[ndigde];
  ind1   = new int[n_wire];
  for (int i=0; i<ndigde; i++) ind[i]  = 0; 
  for (int i=0; i<n_wire; i++) ind1[i] = 0; 
 
  for(int i=0; i<ndigde; i++) {
     vector<digx>::iterator dg = dg_trd->begin() + i;
     dg_srt[i] = dg->strip;
  }    

//sort the digit matrix  due to increasing strip nr
  sortzv_(dg_srt,ind,ndigde,mi1,i0,i0);

// the next loop cleans the digits and fills digb and hitb banks and relations
// In principle ther should be  a code which makes clustering of digits to hits
// since we dont have it at the moment the hits will be obtained directly
// from the mimps, i.e. in parallel to the digits.
// Note that only digits and hits will be stored for which the deposit energy
// in the cell is bigger then e_thr)  

  int iflag = 0,   iflag1 = 0;
   for(int ih = 0; ih < ndigde; ih++) {
//   first the digits
     vector<digx>::iterator dg = dg_trd->begin() + ind[ih] - 1;
     if(de[dg->strip-1] < e_thr) continue;
     mmbook_(ArtePointer<DIGB>::getLink().getRef(),1);
     int nn1 =ArtePointer<DIGB>::nrow() ;
     ArtePointer<DIGB> dgb(nn1);
     if(iflag == 0) {        // first digit in this detector
        gd->dig1 = nn1;        iflag = 1;
     }
     dgb->id  = 10000*dg->strip + ipl ;
     dgb->q   = dg->charge;
     if(dg->mimp) createRelation(ArtePointer<MIMP>(dg->mimp),dgb,&MIMP::digb);
     gd->digl = nn1;
     createRelation(ArtePointer<MIMP>(dg->mimp),dgb,&MIMP::digb);

//   next the hitb bank
     ArtePointer<HITB> htb;

     if(!ind1[dg->strip-1] ) {    
        mmbook_(ArtePointer<HITB>::getLink().getRef(),1);
        int nn = ArtePointer<HITB>::nrow();
        htb = ArtePointer<HITB>(nn);
        if(!iflag1) {
	  gd->hit1 = nn;    iflag1 =1;
        }
        gd->hitl = nn;
        htb->gede = ipl;
        htb->x  = gd->xmin + (float(dg->strip)-.5) * gd->pit;
        htb->z  = gd->zfw[0];
        htb->q  = dg->charge;           
        htb->r  = gd->acc;
        ind1[dg->strip-1] = nn;
     }
     else {
        htb = ArtePointer<HITB>(ind1[dg->strip-1]);
        if(fabs(dg->charge) < fabs(htb->q)) htb->q = dg->charge;
     }    
     createRelation (ArtePointer<MIMP>(dg->mimp),htb,&MIMP::hitb);
     createRelation (htb,dgb,&HITB::digb);
  } 

L99:  
  if(dg_trd != NULL)  {delete dg_trd;      dg_trd = NULL;}
  if(ind != NULL)     {delete [] ind;      ind    = NULL;}
  if(ind1 != NULL)    {delete [] ind1;     ind1   = NULL;}
  if(dg_srt != NULL)  {delete [] dg_srt;   dg_srt = NULL;}
  if(de != NULL)      {delete [] de;       de     = NULL;}     
  }

// End of DGTRDS

