
// *****************************************************************************
//
// source:    faCatchSIG.C
//
// type:      source code
//
// created:   23 Sep 1997
//
// author:    Andreas Gellrich
//            HERA-B Collaboration
//            DESY Zeuthen
//            Platanenallee 6
//            D-15738 Zeuthen
//            Germany
//            email: Andreas.Gellrich@desy.de
//
// changes:         include prototypes here (AG: 23 Feb 99)
//                  polishing (AG: 11 Mar 99)
//                  use atstopc_() (AG: 25 Mar 99)
//                  put includes (AG: 1 Jun 99)
// 18 Aug 1999 (AG) provide only one signal catching routine
//
// *****************************************************************************

// includes
#include <iostream>
#include <signal.h>

#include "farm/fa.hh"

// C prototypes
extern "C" void atstopc_( const char *string , const int count );

// *****************************************************************************
//
// name:      faCatchSIG
//
// purpose:   catch signal and invoke atstopc_()
//
// input:     int  signal number
// return:    void
//
// *****************************************************************************

void
faCatchSIG( int sigNum )
{
#ifdef _OUT_
  cout << "faCatchSIG(): sigNum=" << sigNum << " "
       << "invoking atstopc_ ..."           << endl;
#endif
  atstopc_( "Called from faCatchSIG()", 24 );
}
