
      SUBROUTINE CAFMBK

************************************************************************
*-- Author :    Olga Igonkina   11/03/96
*
* Description:  This routine puts ECAl HITS for electrons and photons
*               to GEANT HIT bank
*
* Called from:  CRHIBK
*
* External references:
*
* Argument in/out description
*
************************************************************************

      IMPLICIT NONE

      INTEGER I,ITMP2,ITMP8, ICUR8, ICUR9, IVN

#include "arte/Arte.fi"
#include "gean/gckine.fi"
#include "gean/gctrak.fi"
#include "gean/gcsets.fi"
#include "gean/gcflag.fi"
#include "auto/GEO.fi"
#include "gean/ZGCALO.fi"
#include "gean/ZGMOTH.fi"
#include "auto/TMP2.fi"
#include "auto/TMP8.fi"
#include "auto/TMP9.fi"
#include "gean/cafmch.fi"
#include "arte/Arte.ff"
#include "auto/GEO.ff"
#include "auto/TMP2.ff"
#include "auto/TMP8.ff"
#include "auto/TMP9.ff"

C.. use parametrization for electrons, positrons and photons
C   incident into the ECAl with energy greater than 4 GeV


      IF( GETOT.GE.4.AND. VECT(6).GE.0.1E-04 .AND.
     +    (VECT(3)-ZZERO-ZACAL(1)).LE.11. )THEN

        CALL CAFMSU
        IF( IHIT.NE.0 )THEN
           DO I = 1, IHIT
              CALL MMBOOK(JTMP8,1)
              CALL MMBOOK(JTMP9,1)
              ITMP8 = JTMP8 + 2 + (NTMP8()-1)*NCTMP8()
              Q(ITMP8+1) = HITPOS(2, I)
              IQ(ITMP8+2) = ITRA
              IQ(JTMP9+2+NTMP9()) = HITPOS(1, I)
              ITMP2 = JTMP2 + 4 + (ITRA-1)*NCTMP2()
              IQ(ITMP2) = IQ(ITMP2) + 1
            ENDDO
        ENDIF
        ISTOP = 1
      ELSE

C for low energetic particles or particles from ECAL shower


         ICUR8 = 2 + (NTMP8()-1)*NCTMP8()
         ICUR9 = 2 + NTMP9()
         IVN = 100*NUMBV(1) + NUMBV(2)*IGCAL_NCL(NUMBV(1))
     +           + NUMBV(3)

c           tracing through the calorimeter
            IF(DESTEP.LE.0.) GO TO 999

c           check whether track number is the same as previous MCAL
            DO 30 I=1,NTMP8()      ! loop over all calorimeter hits
            IF(ITRA.NE.IQ(JTMP8+ICUR8+2)) THEN
               CALL MMBOOK(JTMP8,1)
               CALL MMBOOK(JTMP9,1)
               ITMP8 = JTMP8 + 2 + (NTMP8()-1) * NCTMP8()
               Q(ITMP8+1) = DESTEP
               IQ(ITMP8+2) = ITRA
               IQ(JTMP9+2+NTMP9()) = IVN
               ITMP2 = JTMP2 + 4 + (ITRA-1)*NCTMP2()
               IQ(ITMP2) = IQ(ITMP2) + 1
               GO TO 999
            ELSE
c              check whether it is the same volume element, if so add energy
               IF(IVN.EQ.IQ(JTMP9+ICUR9)) THEN
                  Q(JTMP8+ICUR8+1) = Q(JTMP8+ICUR8+1) +  DESTEP
                  GO TO 999
               ELSE
c                 go to the previous MCAL
                  GO TO 29
               ENDIF
            ENDIF
 29         ICUR8 = ICUR8 - NCTMP8()
 30         ICUR9 = ICUR9 - 1

c           first track, but all MCALs have diff volumina (or first MCAL)

            CALL MMBOOK(JTMP8,1)
            CALL MMBOOK(JTMP9,1)
            ITMP8 = JTMP8 + 2 + (NTMP8()-1)*NCTMP8()
            Q(ITMP8+1) = DESTEP
            IQ(ITMP8+2) = ITRA
            IQ(JTMP9+2+NTMP9()) = IVN
            ITMP2 = JTMP2 + 4 + (ITRA-1)*NCTMP2()
            IQ(ITMP2) = IQ(ITMP2) + 1
            GO TO 999
         ENDIF
 999  RETURN
      END

************************************************************************
* End of CAFMBK
************************************************************************
