/*
pppppppppp   tttttttttttt  ll          bbbbbbbbbbb   uu       uu  fffffffffff
ppppppppppp  tttttttttttt  ll          bbbbbbbbbbbb  uu       uu  fffffffffff
pp       pp       tt       ll          bb        bb  uu       uu  ff
pp       pp       tt       ll          bb        bb  uu       uu  ff
pp       pp       tt       ll          bb       bb   uu       uu  ff
ppppppppppp       tt       ll          bbbbbbbbbb    uu       uu  ffffff
pppppppppp        tt       ll          bbbbbbbbbb    uu       uu  ffffff
pp                tt       ll          bb       bb   uu       uu  ff
pp                tt       ll          bb        bb  uu       uu  ff
pp                tt       ll          bb        bb  uu       uu  ff
pp                tt       llllllllll  bbbbbbbbbbbb  uuuuuuuuuuu  ff
pp                tt       llllllllll  bbbbbbbbbbb    uuuuuuuuu   ff
*/

/**********************************************************************
 *
 * Author: I.Belyaev
 * Date: 1997/10/04 
 *
 * Created: Apr 10, 1997 by Ivan Belyaev
 *
 * Called from: PTLDAT 
 *
 * Description:
 *
 * It reads the lines from file and put them into 
 * FORTRAN common block     PTBUFF
 *
 * Arguments:
 *      
 * name        Argument description
 *
 * name  in     name of file to be opened and read.
 *
 **********************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <iostream.h>
#include <math.h>
#include "gean/ZGESL.h"
#include "gean/hgdat.h"
#include "gean/zgvers.hh"
#include "arte/arte.hh"
#include "arte/ArteMessage.hh"
#include "arte/ArteUtil.h"

/*
  ------------------------------------------------------------------------
*/

static int  PTLBUF_first=1       ;
FILE  *utfilp(const char*,const char*);
static FILE *PTL_inp;
int         ptlbuf( char*);
int const   debug=0       ;

typedef struct 
{
  int  buflen;
  char buffer[256];
} Commonptlbuf;

extern "C" 
{
  int    ptlbuf_( char *name) { return ptlbuf(name); }
  extern Commonptlbuf   ptbuff_    ;
}

//Commonptlbuf   ptbuff_;
char *getenv (const char *name);

/* **************************************************************************
 *  Files are looked in the following directories:                          *
 *   PWD and then in $HB/$HBVERS/geo/                                       *
 ****************************************************************************
 */

/* **************************************************************************
 *                                                                          *
 *    ssssssssss   tttttttttttt   aaaaaaaaaa   rrrrrrrrrrr   tttttttttttt   *
 *   ssssssssssss  tttttttttttt  aaaaaaaaaaaa  rrrrrrrrrrrr  tttttttttttt   *
 *   ss        ss       tt       aa        aa  rr        rr       tt        *
 *   ss                 tt       aa        aa  rr        rr       tt        *
 *   sss                tt       aa        aa  rr        rr       tt        *
 *    sssssssss         tt       aaaaaaaaaaaa  rrrrrrrrrrrr       tt        *
 *     sssssssss        tt       aaaaaaaaaaaa  rrrrrrrrrrr        tt        *
 *            sss       tt       aa        aa  rr    rr           tt        *
 *             ss       tt       aa        aa  rr     rr          tt        *
 *   ss        ss       tt       aa        aa  rr      rr         tt        *
 *   ssssssssssss       tt       aa        aa  rr       rr        tt        *
 *    ssssssssss        tt       aa        aa  rr        rr       tt        *
 *                                                                          *
 ****************************************************************************
 */

int ptlbuf(char* name) 
{
  int    status=0   ;
  char buffer[256];
  Commonptlbuf   & PTLBuffer=ptbuff_;

      /* start message */
  if( debug )
    { arteMsg << "PTLBUF start ===";
      arteMsg.warn();}

  /* start the initialisation procedure */
  if(PTLBUF_first) {
    char dirnam[14];
    zgvers ZGVERS;
     strcpy(dirnam,ZGVERS.Get_vers_datafile(LGESL_PTC));
     PTL_inp = utfilp(name,dirnam); 
     PTLBUF_first =0;
     if(!PTL_inp)
	  { PTLBUF_first = 1;
	    status = -2      ;
	    return status;} }

  if(fgets(buffer,256,PTL_inp) == NULL)
    { status = 0;
      if( feof( PTL_inp ) ) 
	{ status = -1;
	  fclose ( PTL_inp );
          PTLBUF_first = 1;
	  return status; }
      return status;
    }
  {
    /* set buffer lengtht */ 
    int i = 0 ;
    while(buffer[i]!='\n')i++;
    PTLBuffer.buflen=i;
  }
  
  /* put buffer into FORTRAN common block */ 
  strcpy(PTLBuffer.buffer,buffer);
  
      /* bye message */
  if( debug )
    { arteMsg << "PTLBUF Normal end  ===";
      arteMsg.warn();
    }
  
  return 1;
}
/* **************************************************************************
 *                    end of routine(function) ptlbuf                       * 
 ****************************************************************************
 *                                                                          *
 *            EEEEEEEEEEEE  NN        NN  DDDDDDDDD                         *
 *            EEEEEEEEEEEE  NNN       NN  DDDDDDDDDD                        *
 *            EE            NNNN      NN  DD       DD                       *
 *            EE            NN NN     NN  DD        DD                      *
 *            EE            NN  NN    NN  DD        DD                      *
 *            EEEEEEEE      NN   NN   NN  DD        DD                      *
 *            EEEEEEEE      NN    NN  NN  DD        DD                      *
 *            EE            NN     NN NN  DD        DD                      *
 *            EE            NN      NNNN  DD        DD                      *
 *            EE            NN       NNN  DD       DD                       *  
 *            EEEEEEEEEEEE  NN        NN  DDDDDDDDDD                        *   
 *            EEEEEEEEEEEE  NN         N  DDDDDDDDD                         *
 *                                                                          *
 ****************************************************************************
 *                    end of routine(function) ptlbuf                       * 
 ****************************************************************************
 */
