
      SUBROUTINE RFSGEO
************************************************************************
*
* RFSGEO
* written by Siegmund Nowak
*
* Description:  defines rf shielding cylinder
*
* called from GEOMAIN
*
* External references: GSVOLU,GSPOS(P),GSATT,GRADLN,MMBOOK
*
* Changes since last version: no more detector region (mother vol)
*
************************************************************************

      IMPLICIT NONE
      INTEGER IVOL,I,MEDNUM
      REAL PAR(3), XPOS,YPOS,ZPOS
      REAL RIRFS, WDRFS, BDRFS, ZARFS,ZERFS
      CHARACTER*4 MUTT
#include "gean/gcflag.fi"
#include "arte/Arte.fi"
#include "gean/gclink.fi"
#include "gean/ZGMOTH.fi"
#include "auto/GEO.fi"
      DATA RIRFS/.7 /, WDRFS/.0005/, BDRFS/1.2/, ZARFS/2./,ZERFS/190./
#include "arte/Arte.ff"
#include "auto/GEO.ff"

      CALL GSVOLU('RFSH' ,'BOX ' ,MEDNUM(1,'ALUMINIUM') ,PAR ,0 ,IVOL)
      CALL GSATT('RFSH','COLO',2)
      PAR(3) = .5*(FNESL_Z1(MAGNSL) - ZARFS)
      ZPOS = ZZERO + ZARFS + PAR(3)
      MUTT = 'MOTH'
      I=0
 10    I= I + 1
       PAR(1) =  .5*BDRFS
       PAR(2) =  .5*WDRFS
       XPOS = 0.
       YPOS = RIRFS
       CALL GSPOSP('RFSH' ,I ,MUTT ,XPOS , YPOS,ZPOS, 0,'ONLY',PAR,3)
       I = I+1
       CALL GSPOSP('RFSH' ,I ,MUTT ,XPOS ,-YPOS,ZPOS, 0,'ONLY',PAR,3)
       PAR(1) = .5*WDRFS
       PAR(2) = .5*BDRFS
       XPOS = RIRFS
       YPOS = 0.
       I= I + 1
       CALL GSPOSP('RFSH' ,I ,MUTT , XPOS , YPOS,ZPOS, 0,'ONLY',PAR,3)
       I= I + 1
       CALL GSPOSP('RFSH' ,I ,MUTT ,-XPOS , YPOS,ZPOS, 0,'ONLY',PAR,3)
       IF(I .GT. 4) GO TO 90 
       PAR(3) = .5*(ZERFS - FNESL_Z1(MAGNSL))
       IF(PAR(3).LT.5.E-2) GO TO 90
       ZPOS = FNESL_Z1(MAGNSL)+PAR(3)-ZMAGM 
       MUTT = 'MAGN'
       GO TO 10
 90   RETURN
      END
************************   END   RFSGEO    *****************************
