/*
************************************************************************
*
* RIC_ARTE
* written by Siegmund Nowak
*
* This routines allows changes in the automatically produced NEDE/NWAL
* banks for the rich 
*
*       called from G..MAIN
*
* The transferred parameters are
* void ric_arte_(int nnede,int ngwal,char lvols[],int lcopy[],int nlev)  
************************************************************************
*/

#include <stdio.h>
#include "arte/arte.hh"
#include "arte/ArteFlag.h"
#include "arte/ArteMessage.hh"
#include "arte/ArteUtil.h"
#include "gean/gclink.h"
#include "gean/zgeom.h"


void ric_arte(int nnede,int ,char lvols[],int *,int nlev) {

    zgvol ZGVOL;
    char  volname[4];
    union  { int ii; char cname[4];};
    union { int ji; float jx;};
    
    if(nnede) {  
      int nnede1 = nnede;
      ArtePointer<NESL> currsl(zgmoth_.CURRSL);
      ArtePointer<NEDE> currde(nnede);
      if(currsl->fpl == nnede) {
         struct NEDE nede;
         ArtePointer<NEDE>::append(nede);
         nnede1++; 
         ArtePointer<NEDE> nextde(nnede1);      
         *nextde = *currde; 
         nextde->nesl = 0; 
         createRelation(currsl,nextde,&NESL::nede);
         nextde->gmat = 0;      
         ArtePointer<GMAT> gm = currde->gmat;
         createRelation(gm, nextde, &GMAT::nede); 
         currsl->npl = currsl->npl +1 ;
         strncpy(currde->gvol,"    ",4);
         strncpy(volname,nextde->gvol,4);
      }
      else {
         nnede1=nnede;   strncpy(volname,currde->gvol,4);
      }

      int Gvolnum = ZGVOL.Check_Gvol(&lvols[4*nlev-4]);
      int jvos = *(gcbank_.lq + gclink_.jvolum -1 - Gvolnum);
      ji =*(gcbank_.iq + jvos + 2);
      int nin = int(jx);
      for(int in = 1; in <= nin;in++) {
          int jin = *(gcbank_.lq + jvos -1 -in);
          ji = *(gcbank_.iq + jin +1);
          int ivot = int(jx);
          ii =  *(gcbank_.iq+gclink_.jvolum-1 + ivot);
          if(!strncmp(cname,volname,4)) { 
             jx = float(nnede1);  *(gcbank_.iq + jin +2) = ji;    return;}}  
      arteMsg << "ric_arte: volume " << volname << " not found";
      arteMsg.error();        
}}          

/* ric_arte_ */









