// 
//  Author:  Rainer Mankel                     Created:  29-Sep-98
//           Humboldt University Berlin        Modified:  
//  Email:   mankel@ifh.de                     HERA-B Collaboration
// 
#include <iostream.h>
#include <math.h>
#include "rang/VolCone.hh"

//-- Constructor
rangerVolCone::rangerVolCone(){};

//-- Constructor
rangerVolCone::rangerVolCone( rangerGeWa* gewa ) : rangerVolume( gewa ) {
};

//-- Destructor
rangerVolCone::~rangerVolCone(){};

double rangerVolCone::sLength(double zz,
			      double x,
			      double y,
			      double tx,
			      double ty){

  // this intersection finder is still simple but maybe a start
  double xP = 0;
  double yP = 0;
  double zP = 0;
  double txP = 0;
  double tyP = 0;
  rotateParam(x,y,zz,tx,ty,xP,yP,zP,txP,tyP);

  double xL = xP + (z - zP) * txP;  // coordinates in ACS
  double yL = yP + (z - zP) * tyP;  // see Hera-B 97-090 p 67

  double rL2 = xL * xL + yL * yL;

  if (rL2 < (Gewa->xmin()*Gewa->xmin())) return 0;
  if (rL2 > (Gewa->xmax()*Gewa->xmax())) return 0;
  return (sqrt(1 + txP*txP + tyP*tyP));
}

