// 
//  Author:  Rainer Mankel                     Created:  01-Apr-99
//           Humboldt University Berlin        Modified:  
//  Email:   mankel@ifh.de                     HERA-B Collaboration
// 

// class rangerLayPl

#ifndef RANGER_LAYPL_HH
#define RANGER_LAYPL_HH

#include "arte/arte.hh"

class rangerDomLay;

class rangerLayPl {

public:
  rangerLayPl(){};
  rangerLayPl(rangerDomLay* dl,ArtePointer<GEDE> ge,
	      const int subGLay1,const int subGLay2);
  ~rangerLayPl(){};
  ArtePointer<GEDE> ge() { return gede; };
  int subgl1() { return subGL1;};
  int subgl2() { return subGL2;};
  double umin() { return uMin;};
  double umax() { return uMax;};
  void dump(const int level = 1);
private:

  // do not forget sublayer information
  rangerDomLay* dLay;
  ArtePointer<GEDE> gede;
  int subGL1;
  int subGL2;
  double uMin;
  double uMax;
};

#endif
