//  Author:  Alexander Spiridonov              Created:  09.07.99
//
//  Email:   spiridon@ifh.de                   HERA-B Collaboration
// 
// rgextios.C
//            input-output of external seeds 


#include <iostream.h>
#include <iomanip.h>
#include <math.h>
#include <stdio.h>
#include "arte/arte.hh"
#include "arte/RSEG_cmp.hh"
#include "rang/rgExtDef.hh"
#include "rang/zfparext.hh"
#include "rang/zfextse.hh"

extern "C" void rgextios_(const int& ios) {

//   ios = 0 input seeds from rseg
//         1 store seeds as rseg

  switch(ios){

  case 0:
//                             build seeds from segments(rseg->fit=9)

    zfextse_.N_ext_seed = 0;
    for( ArteTableIterator <RSEG> rseg;
	 rseg.valid(); rseg.next() )
      {
	if( rseg->fit == 9 && (rseg->cmp & Rsegc::bitsign)  == 0  
	    && zfextse_.N_ext_seed < NMAX_SEED )
	  {

	    int seed = zfextse_.N_ext_seed;

	    zfextse_.z_seed[seed] = rseg->zf;
	    zfextse_.x_seed[seed] = rseg->xf;
	    zfextse_.y_seed[seed] = rseg->yf;
	    zfextse_.tx_seed[seed] = rseg->txf;
	    zfextse_.ty_seed[seed] = rseg->tyf;
	    zfextse_.q_seed[seed] = rseg->pf;
	    for(int i=0; i < 15; ++i)
	      {zfextse_.cov_seed[seed][i] = rseg->cvf[i];} 

	    zfextse_.seg_VDS[seed] = 0;
	    zfextse_.seg_MUON[seed] = 0;
	    zfextse_.seg_ECAL[seed] = 0;
	    zfextse_.seg_RICH[seed] = 0;
	    zfextse_.seg_OT[seed] = 0;
	    ArtePointer<MTRA> mtra = rseg->mtra.begin();
	    zfextse_.track_MC[seed]=  mtra.index();

	    ++zfextse_.N_ext_seed; 

	  }
      }

    break;

  case 1:
//                             store seeds as segments(rseg->fit=9)
    if(zfextse_.N_ext_seed > 0)
      {
	for(int seed = 0; seed < zfextse_.N_ext_seed; ++seed)
	  {
	    mmbook_(ArtePointer<RSEG>::getLink().getRef(),1);
	    ArtePointer<RSEG> rseg( ArtePointer<RSEG>::nrow() );
	    rseg->zf = zfextse_.z_seed[seed];
	    rseg->xf = zfextse_.x_seed[seed];
	    rseg->yf = zfextse_.y_seed[seed];
	    rseg->txf = zfextse_.tx_seed[seed];
	    rseg->tyf = zfextse_.ty_seed[seed];
	    rseg->pf = zfextse_.q_seed[seed];
	    for(int i=0; i < 15; ++i)
	      {rseg->cvf[i] = zfextse_.cov_seed[seed][i];} 
	    rseg->fit = 9;
	    rseg->cmp = 0;
	    if(zfextse_.seg_VDS[seed]){rseg->cmp = rseg->cmp | Rsegc::vxd;}
	    if(zfextse_.seg_MUON[seed]){rseg->cmp = rseg->cmp | Rsegc::muon;}
	    if(zfextse_.seg_ECAL[seed]){rseg->cmp = rseg->cmp | Rsegc::ecal;}
	    if(zfextse_.seg_RICH[seed]){rseg->cmp = rseg->cmp | Rsegc::rich;}
	    if(zfextse_.seg_OT[seed]){rseg->cmp = rseg->cmp | Rsegc::trit;}
	    if(zfextse_.track_MC[seed])
// 	      {mmbrel_( ArteManRelationPointer<RSMT,RSEG>::getLink().getInt(),
// 		      ArtePointer<RSEG>::nrow(),zfextse_.track_MC[seed]);}
// 	      relations swap
	      {mmbrel_( ArteManRelationPointer<MTRS,RSEG>::getLink().getInt(),
		      zfextse_.track_MC[seed],ArtePointer<RSEG>::nrow());}
	  }
      }
    break;

  default:
//                             build seeds from segments(rseg->fit=9)
    break;

  }
}

