//  Author:  Alexander Spiridonov              Created:  07.06.99
//
//  Email:   spiridon@ifh.de                   HERA-B Collaboration
// 
// rgextspr.C
//            print parameters of ext-seeds 


#include <iostream.h>
#include <iomanip.h>
#include <math.h>
#include <stdio.h>
#include "arte/arte.hh"
#include "rang/rgExtDef.hh"
#include "rang/zfparext.hh"
#include "rang/zfextse.hh"

#define I4 setw(4)<< 
#define I5 setw(4)<< 
#define F8 setw(8)<< 
#define F9 setw(9)<< 
#define F10 setw(10)<< 
#define P3 setprecision(3)<< 
#define P4 setprecision(4)<< 


extern "C"
{
  void rgextspr_()
    {
      cout << setiosflags(ios::fixed);
//      cout << setiosflags(ios::showpoint | ios::uppercase);
      if(zfextse_.N_ext_seed > 0)
	{
	  cout << " LIST OF EXT-SEEDS " << endl;
	  cout << "   n      z        x         y        tx         ty";  
	  cout << "       q/p    mc " << endl;
	  for(int seed=0; seed < zfextse_.N_ext_seed ; seed++)
	    {
	      cout << I4 int(seed+1)  
		   << F10 P3 zfextse_.z_seed[seed]
		   << F9 P3 zfextse_.x_seed[seed]
		   << F9 P3 zfextse_.y_seed[seed]
		   << F10 P3 zfextse_.tx_seed[seed]
		   << F10 P3 zfextse_.ty_seed[seed]
		   << F10 P3 zfextse_.q_seed[seed]
		   << " " << I4 zfextse_.track_MC[seed]
		   << endl;

	    }
	}
      else
	{
	  cout << " LIST OF EXT-SEEDS is empty" << endl;
	}
    }
}
