// 
//  Author:  Rainer Mankel                     Created:  26-Apr-99
//           Humboldt University Berlin        Modified:  
//  Email:   mankel@ifh.de                     HERA-B Collaboration
// 

#include "rang/Domain.hh"
#include "rang/XWin.hh"

extern "C" {
  float rgtxseg_(const rangerDomain*& dm) {
    
    if (dm) {
      if (! dm->xwin()) {
	cout << "rgtxseg: no xwin defined" << endl;
	return 0;
      }
      if (! dm->xwin()->filled()) {
	cout << "rgtxseg: xwin is not filled! dom=" << dm << endl;
	cout << " ... domain dump:" << endl;
	dm->dump();
	return 0;
      }
      return (dm->xwin()->tx()); 
    }
    else {
      cout << " () rgtxseg: domain unavailable" << endl;
      return 0;
    }
  }
}
