// 
//  Author:  Rainer Mankel                     Created:  19-Apr-99
//           Humboldt University Berlin        Modified:  
//  Email:   mankel@ifh.de                     HERA-B Collaboration
// 

#include "rang/DomWin.hh"
#include "rang/DomLay.hh"
#include "rang/NavItem.hh"
#include "rang/rgzone.hh"

extern "C" {
  void rgzonew_(rangerDomWin* const & dw,
		const int& method,
		const int& zone,
		const int& direction,
		const int& minScope,
		const int& maxScope,
		const int& maxExpand,
		const int& maxTarget,
		rangerDomLay** targetVec,
		int& nTarget) {
    
    if (! dw) return;
    if (nTarget >= maxTarget) return;
    if (zone <= 0) return;

    // try to resolve in current window
    rangerDomLay* dln = dw->firstDL(method,direction);

    if (dln) {
      if (zone == 1) {
	++nTarget;
	targetVec[nTarget-1] = dln;
	return;
      }
      else {
	rgzone_(dln,method,zone-1,
		direction,minScope,maxScope,maxExpand,
		maxTarget,targetVec,nTarget);
      }
    }
    else {
      // expand sector map
      if (dw->getNI()) {
	for (vector<rangerNavItem*>::const_iterator 
	       ni= dw->getNI()->getTargets(direction).begin();
	     ni != dw->getNI()->getTargets(direction).end();
	     ++ni) {
// 	    if ((*ni)->win()->firstDL(method,direction)) {
// 	      rgzone_((*ni)->win()->firstDL(method,direction),method,zone-1,
// 		      direction,minScope,maxScope,maxExpand-1,
// 		      maxTarget,targetVec,nTarget);
// 	    }
	  rgzonew_((*ni)->win(),method,zone,
		   direction,minScope,maxScope,maxExpand-1,
		   maxTarget,targetVec,nTarget);
	  if (maxExpand <=0) break;
	}
      }
    }
  }
}
	  
