*-- Author:    A.Spiridonov    23/09/98  /modification of tftparm1.F

      subroutine tftcpars(iseg,edge,imc,pa,pamc,dpa,dpanorm,ch2mc,istat)

*     **** check reconstructed segment parameters against MC
*
*          edge = 0 ,end of segment ; = 1 beginning of segment
*
      implicit none

      double precision covi(5,5)
      real pa(5), pamc(5), dpa(5), ch2mc, ex(5), dpanorm(5), zref
      integer i, j, ndf, ifail, mimp, jaux, assmimp, istat, i_pack, ii,
     +     iseg, edge, imc, hf, ih, icode

      integer nzfmx_s
      parameter (nzfmx_s=300)
      integer rh,iso,ind_rhit,mc,imimp,nimimp,cmp
      real z_test

      real charge, mass, corc(5,5), cms, tx, ty

      character*20 cname

#include "arte/Arte.fi"
#include "rang/zfpar.fi"

#include "auto/HITB.fi"
#include "auto/MIMP.fi"
#include "auto/RHIT.fi"
#include "auto/RTRA.fi"
#include "auto/RSEG.fi"
#include "auto/MTRA.fi"
#include "auto/GEO.fi"
#include "auto/TOPP.fi"

#include "pris/zmpack.fi"

#include "arte/Arte.ff"
#include "auto/HITB.ff"
#include "auto/MIMP.ff"
#include "auto/RHIT.ff"
#include "auto/RTRA.ff"
#include "auto/RSEG.ff"
#include "auto/MTRA.ff"
#include "auto/GEO.ff"
#include "auto/TOPP.ff"

      istat = 0
*   -----------
      ndf = 4
*   -----------

      mimp = 0
      if(edge.eq.0) then                              !  end of segment
        z_test = -1.e10
        zref = frseg_ze(iseg)
        pa(1) = frseg_xe(iseg)
        pa(2) = frseg_ye(iseg)
        pa(3) = frseg_txe(iseg)
        pa(4) = frseg_tye(iseg)
        pa(5) = frseg_pe(iseg)
        do i=1,5
           do j=1,5
              i_pack = matrix_pack(i,j)
              corc(i,j) = frseg_cve(i_pack,iseg)
           enddo
        enddo
      else                                            ! beginning of segment
        z_test =  1.e10
        zref = frseg_zf(iseg)
        pa(1) = frseg_xf(iseg)
        pa(2) = frseg_yf(iseg)
        pa(3) = frseg_txf(iseg)
        pa(4) = frseg_tyf(iseg)
        pa(5) = frseg_pf(iseg)
        do i=1,5
           do j=1,5
              i_pack = matrix_pack(i,j)
              corc(i,j) = frseg_cvf(i_pack,iseg)
           enddo
        enddo
      end if

*     ****        get from segment hit(mimp) 
*     **** lowest z for edge =1, largest  z for edge=0 )

      do 30 iso=1,nzfmx_s
         if (iso.eq.1) then
            ind_rhit = prseg_rhit(iseg)
         else
            ind_rhit = xrseg_rhit(ind_rhit)
         endif
         if (ind_rhit.eq.0) go to 31
         rh = mrseg_rhit(ind_rhit)

*        **** get associated hits

         ih = orhit_hitb(rh)

         cmp = igede_cmp(ihitb_gede(ih))

         if (cmp.lt.1.or.cmp.gt.3) go to 30

         call tuhmimp(ih,mc,imimp,nimimp)

         if(imc.eq.mc.and.imimp.gt.0) then
           if(edge.eq.0) then                          ! large z 
             if(fmimp_z(imimp).ge.z_test) then
               z_test = fmimp_z(imimp)
               mimp = imimp
             end if
           else                                        ! low z
             if(fmimp_z(imimp).le.z_test) then
               z_test = fmimp_z(imimp)
               mimp = imimp
             end if
           end if
         end if

#ifdef FULLPRINT
         if (iso.eq.1)
     +        print '(10x,4a8,a12)','iso','rh','ih','cmp','zhit'
         print '(10x,4i8,f12.2)',iso,rh,ih,cmp,z_s(nzf_s)
#endif

 30   continue
 31   continue

*     **** test mimp

*      call tftcspri(iseg)

      if(mimp.eq.0) then
        istat = -1
        print '("tftcpars : no valid mimp found for segment=",i5
     +         ," imc=",i5)',iseg,imc
        go to 999
      end if
      if (abs(fmimp_z(mimp)-zref).gt.5.) then
         print '("tftcpars : funny z_test,zref= "
     +         ,2(x,f8.3)," for mimp= ",i5)'
     +         , fmimp_z(mimp), zref, mimp
         istat = -1
         go to 999
      endif

      if (mimp.gt.iq(jmimp+2)) then
        print *,' () tftcpars: mimp=', mimp  ! mimp invalid
        go to 999
      endif

*      print '("tftcpars :  z_test,zref= "
*     +         ,2(x,f8.3)," for mimp= ",i5)'
*     +         , fmimp_z(mimp), zref, mimp

      icode = omtra_topp( omimp_mtra(mimp) )
      call tupaty(icode,cname,charge,mass,'G')

      tx = fmimp_tx(mimp)
      ty = fmimp_ty(mimp)

      pamc(1) = fmimp_x(mimp)
     +        + tx * (zref - fmimp_z(mimp))
      pamc(2) = fmimp_y(mimp)
     +        + ty * (zref - fmimp_z(mimp))
      pamc(3) = tx
      pamc(4) = ty
**      pamc(5) = 0.33 * itopp_chrg(icode) / abs(fmimp_p(mimp))
      if (itopp_chrg(icode).gt.0) then
         pamc(5) = 1. / abs(fmimp_p(mimp))
      elseif (itopp_chrg(icode).lt.0) then
         pamc(5) = -1. / abs(fmimp_p(mimp))
      else
         pamc(5) = 0.
         print *,' () tftcpars: invalid charge=',itopp_chrg(icode)
      endif

*     **** add last M.S.

      cms = fgede_ms(imimp_gede(mimp)) / fmimp_p(mimp)**2
      corc(3,3) = corc(3,3) + cms
      corc(4,4) = corc(4,4) + cms

      do i=1,5
         dpa(i) = pa(i) - pamc(i)
         ex(i)  = sqrt(corc(i,i))
         dpanorm(i) = dpa(i) / ex(i)
      enddo

*     **** MC chi2
      ch2mc = 0.
      do i=1,ndf
         do j=1,ndf
            covi(i,j) = corc(i,j)
         enddo
      enddo

*     **** blank remaining elements
      do i=ndf+1,5
         do j=ndf+1,5
            covi(i,j) = 0.d0
         enddo
      enddo

*      write(*,'((a),5(/5e11.3))') 'before inv:',covi
      call dsinv(ndf,covi,5,ifail)
      if (ifail.ne.0) then
         print *,' () tftcpars: mx inversion ifail,seg ',ifail,iseg
         istat = -1
         go to 999
      endif
*      write(*,'((a),5(/5e11.3))') 'after  inv:',covi
      do i=1,ndf
         do j=1,ndf
            ch2mc = ch2mc + dpa(i) * dpa(j) * covi(i,j)
**          print *,' chi2 contr, i,j,contr=',
**     +            i,j,dpa(i) * dpa(j) * covi(i,j)
         enddo
      enddo

      if (ifail.ne.0) then 
        print *,'tftcpars : =====> ifail,chi2=',ifail,ch2mc
        istat = -2
      end if

 999  end
