*-- Author :    Rainer Mankel   22/03/96

      subroutine tftripxn(tabl,dir)

*     **** search triplets in 0-deg layers of domain

*     **** inspired by Christophs sort scheme
      implicit none
#include "rang/zdomain.fi"
#include "rang/ztripl.fi"
#include "arte/Arte.fi"
#include "rang/zfmode.fi"
#include "rang/zfpar.fi"
#include "auto/GEO.fi"
#include "auto/HITB.fi"

      real dxmax,dzmin,txmax,dtxmax,dxclus,dtxclus,zref,dz1,tx1,dz2,
     +        tx2,sum_z,dx,dtx,tx_nsig,dtxres
      integer lay,iih,idh,hitb,cmp,isig,ind1,ind2,ind3,s1,
     +     s2,s3,t1,t2,tlast,ii,jj,kk,set0,trip0,clus0,
     +     ref,trip,clus,t,trip_found,clus_found,n_z
      integer maxref
      parameter (maxref=1000)
      integer nref,vecref(maxref)
      integer maxhc
      parameter (maxhc=300)
      integer nhc,hit_hc(maxhc),indhc(maxhc),
     +     nhit_current,hc
      integer message_id_1, message_id_2 , message_id_3,
     +     message_id_4
      logical init
      integer tabl,dir
      integer maxseed,maxlay,maxhit
      parameter (maxseed=50,maxlay=6,maxhit=100)
      integer vseed(maxseed),vlay(maxlay),vhit(maxhit)
      integer nseed,nlay,nhit
      integer iseed,ilay,ihit
      real rgzlay

      data message_id_1 /1/,message_id_2 /2/,message_id_3 /3/,
     +     message_id_4 /4/
      data init /.false./
      save message_id_1, message_id_2, message_id_3,
     +     message_id_4, init


#include "arte/Arte.ff"
#include "auto/GEO.ff"
#include "auto/HITB.ff"

      dxmax = 20.               ! maximum x difference for doublets
      dzmin = 0.1               ! minimum z difference for doublets
      txmax = 1.                ! maximum slope for doublets
      dtxmax = 0.02             ! maximum slope difference for triplets
      tx_nsig = 2.              !          ||   in sigmas

      dxclus = .06              ! maximum x  difference for cluster
      dtxclus = 0.02            ! maximum tx difference for cluster



**      diag_level = 5
**      l_diag = .true.


**      print *,' tftripxn: dom=',dom,' win1=', win1_dm(dom)

**      call tftriref(dom,maxref,nref,vecref) ! get ref tracks

      nset = 0                  ! reset hit set structure
      ntrip = 0
      nclus = 0
      nsetx = 0
      ntripx = 0
      nclusx = 0

      call rgtabss(tabl,1,maxseed,vseed,nseed)

**      print *,' tftripxn: rgtabss returns nseed=',nseed

      do iseed=1,nseed
         call rgsdlay(vseed(iseed),maxlay,vlay,nlay)
**         print *,' tftripxn: rgdslay returns nlay=',nlay
        
**      do win=win1_dm(dom),win1_dm(dom)+nwin_dm(dom)-1
**     +                          ! loop over domain windows
**        print *,' tftripxn: check win=', win,' sector', secshad_dw(win)

         if (nlay.lt.3) go to 71

         sum_z = 0.
         n_z = 0
         do 40 ilay=1,nlay
            sum_z = sum_z + rgzlay(vlay(ilay))
            n_z = n_z + 1
 40      continue
 41      continue
         zref = sum_z / n_z

**         zref = 0.5 * (zmax_dw(win) + zmin_dw(win)) ! reference
**         print *,' zref,zmax,zmin=', zref,zmax_dw(win),zmin_dw(win)
         set0 = nset            ! startpointer for set structure

         do 90 ilay=1,nlay      ! loop over 0-deg layers
            lay = vlay(ilay)
            if (lay.eq.0) go to 91
            call rghl(lay,maxhit,vhit,nhit)
**            print *,' tftripxn: rghl returns nhit=',nhit
            do 60 ihit=1,nhit   ! loop over hits in layer
               hitb = vhit(ihit)
               if (segstor_zfpar) then ! check if hit already used
                  if (phitb_rseg(hitb).gt.0) go to 60 
               else
                  if (phitb_rtra(hitb).gt.0) go to 60 
               endif
               cmp = igede_cmp(ihitb_gede(hitb))

               if (nset.le.(maxset-2)) then
                  if (cmp.eq.1.or.cmp.eq.3) then ! strip
                     nset = nset + 1
                     x_set(nset) = fhitb_x(hitb)
                     z_set(nset) = fhitb_z(hitb)
                     hit_set(nset) = hitb
                     sig_set(nset) = 0
                     dl_set(nset) = lay
                     indset(nset) = nset
                  elseif (cmp.eq.2) then ! wirech
                     do isig=-1,1,2
                        nset = nset + 1
                        x_set(nset) = fhitb_x(hitb)
     +                       + isig * abs(fhitb_q(hitb))
                        z_set(nset) = fhitb_z(hitb)
                        hit_set(nset) = hitb
                        sig_set(nset) = isig
                        dl_set(nset) = lay
                        indset(nset) = nset
                     enddo
                  else
                     print *,' () tftripxn: invalid cmp=', cmp,
     +                    ' pl=',igede_cmp(ihitb_gede(hitb)),
     +                    ' sl=',ogede_gesl(ihitb_gede(hitb)),
     +                    ' hit=',hitb
                  endif
               else
                  call mepric(message_id_1,1,
     +                 'tftripxn: overflowing nset, hits skipped')
                  go to 91
               endif
 60         continue            ! hits in layer
 61         continue
 90      continue               ! layers
 91      continue

*        **** sort the hit set (increasing x)
         call sortzv(x_set,indset(set0+1),nset-set0,+1,0,1)

*        **** sample hit triplets
         trip0 = ntrip
         do 10 ind1=set0+1,nset-2    ! loop over base hit
            s1 = indset(ind1)
            do 20 ind2=ind1+1,nset-1 ! loop over second hit
               s2 = indset(ind2)
               if ((x_set(s2)-x_set(s1)).gt.dxmax) go to 21
               dz1 = z_set(s2) - z_set(s1)
               if (abs(dz1).lt.dzmin) go to 20
               tx1 = (x_set(s2)-x_set(s1)) / dz1
               if (abs(tx1).gt.txmax) go to 20
               do 30 ind3=ind2+1,nset ! loop over third hit
                  s3 = indset(ind3)
                  if ((x_set(s3)-x_set(s1)).gt.dxmax) go to 31
                  dz2 = z_set(s3) - z_set(s1)
                  if (abs(dz2).lt.dzmin) go to 30
                  tx2 = (x_set(s3) - x_set(s1)) / dz2
                  if (abs(tx2).gt.txmax) go to 30

                  dtxres = tx_nsig * sqrt(
     +                 (1./dz2 - 1./dz1)**2 * fhitb_r(hit_set(s1))**2
     +                 + (1./dz1)**2 * (fhitb_r(hit_set(s2)))**2
     +                 + (1./dz2)**2 * (fhitb_r(hit_set(s3)))**2 )

**                  if (abs(tx1-tx2).lt.dtxmax) then ! triplet found
                  if (abs(tx1-tx2).lt.dtxres) then ! triplet found
                     if (ntrip.lt.maxtrip) then
                        ntrip = ntrip + 1
                        zref_trip(ntrip) = zref
                        tx_trip(ntrip) = 0.5 * (tx1 + tx2)
                        x_trip(ntrip) = x_set(s1)
     +                       + (zref-z_set(s1)) * tx_trip(ntrip)
                        s_trip(1,ntrip) = s1
                        s_trip(2,ntrip) = s2
                        s_trip(3,ntrip) = s3
                        clus_trip(ntrip) = 0
                        nx_trip(ntrip) = 0
                        indtrip(ntrip) = ntrip
                     else
                        call mepric(message_id_2,1,
     +                     'tftripxn: overflowing ntrip, sets skipped')
                        go to 11
                     endif
                  endif
 30            continue ! third hit
 31            continue
 20         continue ! second hit
 21         continue
 10      continue ! base hit
 11      continue

         if (l_diag) then
            if (diag_level.ge.5) then
               print *,' tftripxn: ',ntrip-trip0,
     +              ' Triplets found for iseed=',iseed
            endif
         endif

*        **** search triplet clusters
         call sortzv(tx_trip,indtrip(trip0+1),ntrip-trip0,+1,0,1)
     +                          ! sort tx

         clus0 = nclus
         do 50 ind1=trip0+1,ntrip    ! loop over first triplet
            t1 = indtrip(ind1)
            tlast = t1
            if (clus_trip(t1).gt.0) go to 50
            if (nclus.lt.maxclus) then
               nclus = nclus + 1 ! create cluster with this hit
               mult_clus(nclus) = 1
               trip1_clus(nclus) = t1
**               indclus(nclus) = nclus
            else
               call mepric(message_id_3,1,
     +              'tftripxn: overflowing nclus, triplets skipped')
               go to 51
            endif
            clus_trip(t1) = nclus
            do ind2=ind1+1,ntrip ! loop over following triplets
               t2 = indtrip(ind2)
               if ((tx_trip(t2)-tx_trip(t1)).gt.dtxclus) go to 50
               if (abs(x_trip(t2)-x_trip(t1)).lt.dxclus) then
                  clus_trip(t2) = nclus ! add to same cluster
                  mult_clus(nclus) = mult_clus(nclus) + 1
                  if (tlast.gt.0) nx_trip(tlast) = t2
                  tlast = t2
               endif
            enddo
 50      continue
 51      continue

**         print *,' analyze clusters ', clus0+1,' to ',nclus

         if (l_diag) then
            if (diag_level.ge.5) then
               print *,' tftripxn: ',nclus-clus0,
     +              ' Clusters found '
            endif
         endif


         do clus=clus0+1,nclus    ! cluster analysis
            nhc = 0
            do 80 jj=1,99          ! locate triplets in cluster
               if (jj.eq.1) then
                  t = trip1_clus(clus)
               else
                  t = nx_trip(t)
               endif
               if (t.le.0) go to 81
               if (nhc.lt.(maxhc-3)) then
                  nhc = nhc + 1
                  hit_hc(nhc) = hit_set(s_trip(1,t))
                  indhc(nhc) = nhc
                  nhc = nhc + 1
                  hit_hc(nhc) = hit_set(s_trip(2,t))
                  indhc(nhc) = nhc
                  nhc = nhc + 1
                  hit_hc(nhc) = hit_set(s_trip(3,t))
                  indhc(nhc) = nhc
               else
                  call mepric(message_id_4,1,
     +                 'tftripxn: overflowing nhc, clusters skipped')
                  go to 81
               endif
 80         continue
 81         continue
         enddo

      enddo     ! seeds windows
 71   continue

      if (l_diag) then
         if (diag_level.ge.5) then
            print *,' tftripxn: sets=', nset,'  triplets=', ntrip,
     +           '  clusters=', nclus
         endif
      endif

      nsetx = nset
      ntripx = ntrip
      nclusx = nclus

**      l_diag = .false.
**      diag_level = 0

      end

