// ********************************************************************
//
//  Routine:      rc99AVDS
//
//  Description:  silicon stand alone reconstruction
//
//  Modification:
//
// ********************************************************************

#include <iostream.h>
#include <stdlib.h>
#include "arte/arte.hh"
#include "silarte/silarte.hh"
#include "cats/cats.h"
#include <rang/rgfit.hh>

//int  SvdEvnt();
//void HolmesEvent();

extern int recoVDSmodule;



//*****************************************************************
// function
//*****************************************************************

int rc99AVDS(int level) {

//==================================================================
// 1. create hits for data
//==================================================================

     int flag = 0;
     if (level ==1 || level ==3 ){
       if (ArteTable<MTRA>::begin() == ArteTable<MTRA>::end()){
         flag = SvdEvnt();
       };
     };

//==================================================================
// 2. reconstruction
//==================================================================

     if ( level > 1 ) {
      if (recoVDSmodule == 1 || recoVDSmodule == 3) HolmesEvent();
      if (recoVDSmodule == 2 || recoVDSmodule == 3) CatsEvent();
     };

//==================================================================
// 3. fill number of hits in rseg bank
// 4. do a refit
//==================================================================

   for( ArteTable<RSEG>::iterator rseg = ArteTable<RSEG>::begin();
        rseg != ArteTable<RSEG>::end(); ++rseg ) {
   
     if ((*rseg)->cmp == 1) {

        int ns=0,nN=0,nP=0;
        for (ArteRelationIterator<HITB> ihitb=(*rseg)->hitb.begin(); 
             ihitb!=(*rseg)->hitb.end(); ++ihitb) {
          ns++;
          int layer=(*ihitb)->gede->lay;
          if (layer==1 || layer==4) nP++;
          if (layer==2 || layer==3) nN++;
        };

        (*rseg)->time = nP;
        (*rseg)->dtim = nN;

// refit
       for( ArteRelationIterator<RHIT> rhit = (*rseg)->rhit.begin();
            rhit != (*rseg)->rhit.end(); ++rhit ) {
        (*rhit)->p = 0.2;
       };

        int fitflag   = (*rseg)->fit;
        int rs        = (*rseg) - ArtePointer<RSEG>(1) + 1;
	int fitstatus = rgfit_(rs,0);
        (*rseg)->fit  = fitflag;


     };

   };

     return flag;
}
