#include <algo.h>
#include <arte/arte.hh>
#include <arte/artefunc.h>

#include <rang/Track.hh>
#include <rang/Node.hh>
#include <rang/Geom.hh>
#include <rang/rgfit.hh>

//void alignSingleSeg(ArtePointer<RSEG>);

void rc99Arefit(){


  for( ArteTable<RTRA>::iterator rtra = ArteTable<RTRA>::begin();
       rtra != ArteTable<RTRA>::end(); ++rtra ) {
    if( (*rtra)->hsi>0 ) {

//------------------------------------------------------------------
// get the silicon segment and do a refit
//
// global alignment effect are not taken into account
//
//------------------------------------------------------------------

  for( ArteRelationIterator<RSEG> rseg = (*rtra)->rseg.begin();
       rseg != (*rtra)->rseg.end(); ++rseg ) {
    if ((*rseg)->cmp == 1){

       for( ArteRelationIterator<RHIT> rhit = (*rseg)->rhit.begin();
            rhit != (*rseg)->rhit.end(); ++rhit ) {
        (*rhit)->p = (*rtra)->pf;
       };

      (*rseg)->pf = (*rtra)->pf;
      (*rseg)->cvf[14] = (*rtra)->cvf[14];

      int rsegFit = (*rseg)->fit;

      int rs        = *rseg - ArtePointer<RSEG>(1) + 1;
      int fitstatus = rgfit_(rs,0);
      //      alignSingleSeg(*rseg);

      (*rseg)->fit    =  rsegFit;


      if( fitstatus >= 0 ) {

        (*rtra)->chi  =  (*rseg)->chi;
        (*rtra)->zf   =  (*rseg)->zf;
        (*rtra)->xf   =  (*rseg)->xf;
        (*rtra)->yf   =  (*rseg)->yf;
        (*rtra)->txf  =  (*rseg)->txf;
        (*rtra)->tyf  =  (*rseg)->tyf;

        (*rtra)->cvf[10] = (*rtra)->cvf[10] * sqrt((*rseg)->cvf[0]/(*rtra)->cvf[0]);
        (*rtra)->cvf[11] = (*rtra)->cvf[11] * sqrt((*rseg)->cvf[2]/(*rtra)->cvf[2]);
        (*rtra)->cvf[12] = (*rtra)->cvf[12] * sqrt((*rseg)->cvf[5]/(*rtra)->cvf[5]);
        (*rtra)->cvf[13] = (*rtra)->cvf[13] * sqrt((*rseg)->cvf[9]/(*rtra)->cvf[9]);

        for (int i=0; i<=9 ; i++) (*rtra)->cvf[i] = (*rseg)->cvf[i];
      } else {
        (*rtra)->fit  = 1000; 
      };
    };
  };
  };
};
};
