// ********************************************************************
//
//  Routine:      kamatch_
//  Author:       T. Oest
//
//  Description:  kuip command RECO/MATCH
//
//  Modification:
//
// ********************************************************************

// includes

int matchVdsEcal     = 0;
int matchVdsRich     = 0;
int matchVdsEcalRich = 0;
int matchTarget      = 0;

int matchMARPLEVdsEcal  = 0;
int matchMARPLEVdsRich  = 0;
int matchMARPLEEcalRich = 0;


extern short MARPLE_MAKERSEG; 

/************************************************************************
* KAMATCH
*
* called from  KUIP
***********************************************************************/
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <ctype.h>
//#include "arte/Arte.hh"

extern "C" void kugetc_( char*, int *, int );


extern "C" void kamatch_() {   

//---------------------------------------------------------------
//   read in subdetector 1,2,3
//---------------------------------------------------------------

  int len1, len2, len3;
  int lenmax = 6;
  char subd1[7], subd2[7], subd3[7];
  kugetc_(subd1, &len1, lenmax);
  kugetc_(subd2, &len2, lenmax);
  kugetc_(subd3, &len3, lenmax);

  subd1[len1+1] = 0;
  subd2[len2+1] = 0;
  subd3[len3+1] = 0;

  for(int i=0; i<len1; i++) subd1[i] = toupper(subd1[i]);
  for(int i=0; i<len2; i++) subd2[i] = toupper(subd2[i]);
  for(int i=0; i<len3; i++) subd3[i] = toupper(subd3[i]);

//---------------------------------------------------------------
//   read in subdetector 1,2,3
//---------------------------------------------------------------
   int VDS  = 0; 
   int ECAL = 0;
   int RICH = 0;

   if (!strncmp(subd1,"ALL",3) || !strncmp(subd2,"ALL",3)) {
     VDS = 1;
     ECAL = 1;
     RICH = 1;
   } else {


   if (!strncmp(subd1,"VDS",3) || !strncmp(subd2,"VDS",3) || 
       !strncmp(subd3,"VDS",3) ) VDS = 1;

   if (!strncmp(subd1,"SVD",3) || !strncmp(subd2,"SVD",3) || 
       !strncmp(subd3,"SVD",3) ) VDS = 1;

   if (!strncmp(subd1,"ECAL",4) || !strncmp(subd2,"ECAL",4) || 
       !strncmp(subd3,"ECAL",4) ) ECAL = 1;

   if (!strncmp(subd1,"RICH",4) || !strncmp(subd2,"RICH",4) || 
       !strncmp(subd3,"RICH",4) ) RICH = 1;

   }
//---------------------------------------------------------------
//   marple matching
//---------------------------------------------------------------

  if (!strncmp(subd1,"MARP",4)) {
    MARPLE_MAKERSEG = 1;
   if (VDS == 1 && ECAL == 1 ) matchMARPLEVdsEcal  = 1;
   if (RICH == 1 && ECAL == 1) matchMARPLEEcalRich = 1;
   if (VDS == 1 && RICH == 1 ) matchMARPLEVdsRich  = 1;
   if (!strncmp(subd2,"TAR",3)) matchMARPLEVdsRich= 1;

   printf(" MARPLE will call : \n");
   if( matchMARPLEVdsEcal )  printf(" match svd  ecal \n");
   if( matchMARPLEEcalRich ) printf(" match rich ecal \n");
   if( matchMARPLEVdsRich )  printf(" match svd  rich \n");

   return;

//---------------------------------------------------------------
//   fit98 matching
//---------------------------------------------------------------
  }else{
    //matchVdsEcalRich = 1;
    //matchVdsEcal     = 1;
    //matchVdsRich     = 1;
    //matchTarget      = 1;

    if (VDS == 1 && ECAL == 1 && RICH == 1) matchVdsEcalRich = 1;
    if (VDS == 1 && ECAL == 1 && RICH == 0) matchVdsEcal     = 1;
    if (VDS == 1 && ECAL == 0 && RICH == 1) matchVdsRich     = 1;
    if (VDS == 0 && ECAL == 1 && RICH == 1) matchTarget      = 1;
    if (!strncmp(subd1,"TAR",3)           ) matchTarget      = 1;
    
  };

   return;
};

