*CMZ :          20/05/96  12.58.34  by  Unknown
*-- Author :   T.Lohse
c
c------------------------------------------------------------
c
c       function:   VTCHI2(iv,k,xk,qk,b13,a33,a34,momflg) R*8
c
c       input:    iv       =  vertex index      Int
c                 k        =  track ind on vtx  Int
c                 xk(3)    =  vertex position   R*8
c                 qk(2)    =  slope of track    R*8
c                 b13      =  d(bx)/d(qx)       R*8
c                 a33      =  d(bx)/d(zv)       R*8
c                 a34      =  d(by)/d(zv        R*8
c                 momflg   =  flag for mom. fit Int
c
c       value:    chi**2 with respect to current vertex
c
c------------------------------------------------------------
c
      double precision 
     1  function VTCHI2(iv,k,xk,qk,b13,a33,a34,momflg)

      implicit none

      integer iv, k, momflg
      double precision 
     1  xk(3), qk(3), b13, a33, a34

      double precision 
     1  chi2f, sum
      double precision 
     1  dp(5), dx(3)
      integer i, j, l, it, imax

#include "vt/vtdat.fi"

      it = ktr(iv,k)
      l  = k-1

      do  i = 1, 3
        dx(i) = xk(i) - xv(i,iv,l)
      enddo
      dp(1) = p(1,it) - qk(1)
      dp(2) = p(2,it) - qk(2)
      dp(3) = p(3,it) - xk(1)
     1                - xk(3)*a33 - b13*qk(1) - a33*b13
      dp(4) = p(4,it) - xk(2)
     1                - xk(3)*a34 - b13*qk(2) - a34*b13
      if (momflg.ne.0)  dp(5) = p(5,it) - qk(3)

      if (momflg.eq.0) then
        imax = 4
      else
        imax = 5
      endif

      chi2f = 0.d0

      do  i = 1, imax
        chi2f = chi2f + dp(i)**2*G(i,i,it)
      enddo
      do  i = 1, imax-1
        sum = 0.
        do  j = i+1, imax
          sum = sum + dp(j)*G(i,j,it)
        enddo
        chi2f = chi2f + 2.*dp(i)*sum
      enddo
      do  i = 1, 3
        chi2f = chi2f + dx(i)**2*CINV(i,i,iv,l)
      enddo
      do  i = 1, 2
        sum = 0.
        do  j = i+1, 3
          sum = sum + dx(j)*CINV(i,j,iv,l)
        enddo
        chi2f = chi2f + 2.*dx(i)*sum
      enddo

      VTCHI2 = chi2f

      return
      end
