*CMZ :          21/07/97  18.49.06  by  Unknown
*-- Author :   T.Lohse
c
c-------------------------------------------------------------
c
c       subroutine:   VTIDWI(it1,it2,ch2max)
c
c       input:    it1  = starting track number            Int
c                 it2  = last track number                Int
c                 ch2max = max distance wire-track        R*8
c                          (chi**2, ndf=1)
c
c       output:   none
c
c       action:   assign tracks to wires and fill common VTWITR
c
c-------------------------------------------------------------
c
      subroutine  VTIDWI(it1,it2,ch2max)

      implicit none

#include "vt/vtdat.fi"
#include "vt/vtwire.fi"
#include "vt/vtpatt.fi"

      integer iw,it1,it2,iit,iwmin
      double precision 
     1  ch2min, ch2i, ch2max

      call VTWITR(it1,it2)

      do  iit = it1, it2
        iwitr(iit) = 0
c---> only tracks which were not yet forced onto a vertex
        if (nv(iit).eq.0) then
          iwmin = 1
          do  iw = 1, nw
            ch2i = ch2wi(iw,iit)
            if (iw.eq.1) ch2min = ch2i
            if ( ch2i .lt. ch2min ) then
              iwmin = iw
              ch2min = ch2i
            endif
          enddo
          if ( ch2min .lt. ch2max ) then
            iwitr(iit) = iwmin
            ntrwi(iwmin) = ntrwi(iwmin) + 1
            itrwi(iwmin,ntrwi(iwmin)) = iit
          endif
        endif
      enddo

      return
      end
